unit Unit_Complexe;

interface

uses
	Sysutils, Math, classes;

type
	Complexe = class
	protected
		FRe : Extended;
		FIm : Extended;
  private
  public
		constructor Create(Re, Im : Extended);
    procedure Addition(Result, C2 : Complexe);
    procedure Multiplication(Result, C2 : Complexe);
    function Module : Extended;
    procedure Polynome(Result : Complexe; Degree : Integer);
  	property Re : Extended Read FRe Write FRe;
  	property Im : Extended Read FIm Write FIm;
end;

var
  i, c, z : Complexe;

implementation

{ Complexe }

constructor Complexe.Create(Re, Im: Extended);
begin
	FRe := Re;
	FIm := Im;
end;

procedure Complexe.Addition(Result, C2: Complexe);
begin
	Result.Re := Self.Re + C2.Re;
  Result.Im := Self.Im + C2.Im;
end;

procedure Complexe.Multiplication(Result, C2: Complexe);
begin
	Result.Re := Self.Re * C2.Re - Self.Im * C2.Im;
  Result.Im := Self.Re * C2.Im + Self.Im * C2.Re;
end;

function Complexe.Module: Extended;
begin
	Result := Sqr(Self.Re) + Sqr(Self.Im);
end;

procedure Complexe.Polynome(Result : Complexe; Degree : Integer);
var
  Index : Integer;
	Reelle, Imaginaire : Extended;
begin
	Result.Re := Self.Re;
	Result.Im := Self.Im;
	i.Re := Self.Re;
	i.Im := Self.Im;
	for Index := 2 to Degree do
  begin
		Reelle := Result.Re * i.Re - Result.Im * i.Im;
	  Imaginaire := Result.Re * i.Im + Result.Im * i.Re;
		Result.Re := Reelle;
		Result.Im := Imaginaire;
  end;
end;

end.
